// @license magnet:?xt=urn:btih:8e4f440f4c65981c5bf93c76d35135ba5064d8b7&dn=apache-2.0.txt Apache-2.0
// @source: https://gitlab.matrix.org/matrix-org/olm/-/tree/3.2.3

var Olm = (function() {
var olm_exports = {};
var onInitSuccess;
var onInitFail;


var Module = (function() {
  var _scriptDir = typeof document !== 'undefined' && document.currentScript ? document.currentScript.src : undefined;
  if (typeof __filename !== 'undefined') _scriptDir = _scriptDir || __filename;
  return (
function(Module) {
  Module = Module || {};


var a;a||(a=typeof Module !== 'undefined' ? Module : {});var aa,ba;a.ready=new Promise(function(b,c){aa=b;ba=c});var g;if("undefined"!==typeof window)g=function(b){window.crypto.getRandomValues(b)};else if(module.exports){var ca=require("crypto");g=function(b){var c=ca.randomBytes(b.length);b.set(c)};process=global.process}else throw Error("Cannot find global to attach library to");
if("undefined"!==typeof OLM_OPTIONS)for(var da in OLM_OPTIONS)OLM_OPTIONS.hasOwnProperty(da)&&(a[da]=OLM_OPTIONS[da]);a.onRuntimeInitialized=function(){h=a._olm_error();olm_exports.PRIVATE_KEY_LENGTH=a._olm_pk_private_key_length();onInitSuccess&&onInitSuccess()};a.onAbort=function(b){onInitFail&&onInitFail(b)};var ea={},l;for(l in a)a.hasOwnProperty(l)&&(ea[l]=a[l]);var ha=!1,m=!1,ia=!1,ja=!1;ha="object"===typeof window;m="function"===typeof importScripts;
ia="object"===typeof process&&"object"===typeof process.versions&&"string"===typeof process.versions.node;ja=!ha&&!ia&&!m;var n="",ka,la,ma,na,oa;
if(ia)n=m?require("path").dirname(n)+"/":__dirname+"/",ka=function(b,c){na||(na=require("fs"));oa||(oa=require("path"));b=oa.normalize(b);return na.readFileSync(b,c?null:"utf8")},ma=function(b){b=ka(b,!0);b.buffer||(b=new Uint8Array(b));b.buffer||q("Assertion failed: undefined");return b},1<process.argv.length&&process.argv[1].replace(/\\/g,"/"),process.argv.slice(2),process.on("uncaughtException",function(b){throw b;}),process.on("unhandledRejection",q),a.inspect=function(){return"[Emscripten Module object]"};
else if(ja)"undefined"!=typeof read&&(ka=function(b){return read(b)}),ma=function(b){if("function"===typeof readbuffer)return new Uint8Array(readbuffer(b));b=read(b,"binary");"object"===typeof b||q("Assertion failed: undefined");return b},"undefined"!==typeof print&&("undefined"===typeof console&&(console={}),console.log=print,console.warn=console.error="undefined"!==typeof printErr?printErr:print);else if(ha||m)m?n=self.location.href:"undefined"!==typeof document&&document.currentScript&&(n=document.currentScript.src),
_scriptDir&&(n=_scriptDir),0!==n.indexOf("blob:")?n=n.substr(0,n.lastIndexOf("/")+1):n="",ka=function(b){var c=new XMLHttpRequest;c.open("GET",b,!1);c.send(null);return c.responseText},m&&(ma=function(b){var c=new XMLHttpRequest;c.open("GET",b,!1);c.responseType="arraybuffer";c.send(null);return new Uint8Array(c.response)}),la=function(b,c,d){var e=new XMLHttpRequest;e.open("GET",b,!0);e.responseType="arraybuffer";e.onload=function(){200==e.status||0==e.status&&e.response?c(e.response):d()};e.onerror=
d;e.send(null)};a.print||console.log.bind(console);var pa=a.printErr||console.warn.bind(console);for(l in ea)ea.hasOwnProperty(l)&&(a[l]=ea[l]);ea=null;var qa;a.wasmBinary&&(qa=a.wasmBinary);var noExitRuntime=a.noExitRuntime||!0;"object"!==typeof WebAssembly&&q("no native wasm support detected");
function r(b){var c="i8";"*"===c.charAt(c.length-1)&&(c="i32");switch(c){case "i1":t[b>>0]=0;break;case "i8":t[b>>0]=0;break;case "i16":ra[b>>1]=0;break;case "i32":u[b>>2]=0;break;case "i64":sa=[0,(w=0,1<=+Math.abs(w)?0<w?(Math.min(+Math.floor(w/4294967296),4294967295)|0)>>>0:~~+Math.ceil((w-+(~~w>>>0))/4294967296)>>>0:0)];u[b>>2]=sa[0];u[b+4>>2]=sa[1];break;case "float":ta[b>>2]=0;break;case "double":ua[b>>3]=0;break;default:q("invalid type for setValue: "+c)}}
function va(b,c){c=c||"i8";"*"===c.charAt(c.length-1)&&(c="i32");switch(c){case "i1":return t[b>>0];case "i8":return t[b>>0];case "i16":return ra[b>>1];case "i32":return u[b>>2];case "i64":return u[b>>2];case "float":return ta[b>>2];case "double":return ua[b>>3];default:q("invalid type for getValue: "+c)}return null}var wa,xa=!1,ya="undefined"!==typeof TextDecoder?new TextDecoder("utf8"):void 0;
function x(b,c){if(b){var d=y,e=b+c;for(c=b;d[c]&&!(c>=e);)++c;if(16<c-b&&d.subarray&&ya)b=ya.decode(d.subarray(b,c));else{for(e="";b<c;){var f=d[b++];if(f&128){var k=d[b++]&63;if(192==(f&224))e+=String.fromCharCode((f&31)<<6|k);else{var p=d[b++]&63;f=224==(f&240)?(f&15)<<12|k<<6|p:(f&7)<<18|k<<12|p<<6|d[b++]&63;65536>f?e+=String.fromCharCode(f):(f-=65536,e+=String.fromCharCode(55296|f>>10,56320|f&1023))}}else e+=String.fromCharCode(f)}b=e}}else b="";return b}
function z(b,c,d,e){if(!(0<e))return 0;var f=d;e=d+e-1;for(var k=0;k<b.length;++k){var p=b.charCodeAt(k);if(55296<=p&&57343>=p){var v=b.charCodeAt(++k);p=65536+((p&1023)<<10)|v&1023}if(127>=p){if(d>=e)break;c[d++]=p}else{if(2047>=p){if(d+1>=e)break;c[d++]=192|p>>6}else{if(65535>=p){if(d+2>=e)break;c[d++]=224|p>>12}else{if(d+3>=e)break;c[d++]=240|p>>18;c[d++]=128|p>>12&63}c[d++]=128|p>>6&63}c[d++]=128|p&63}}c[d]=0;return d-f}
function A(b){for(var c=0,d=0;d<b.length;++d){var e=b.charCodeAt(d);55296<=e&&57343>=e&&(e=65536+((e&1023)<<10)|b.charCodeAt(++d)&1023);127>=e?++c:c=2047>=e?c+2:65535>=e?c+3:c+4}return c}function za(b,c){for(var d=0;d<b.length;++d)t[c++>>0]=b.charCodeAt(d)}var Aa,t,y,ra,u,ta,ua;
function Ba(){var b=wa.buffer;Aa=b;a.HEAP8=t=new Int8Array(b);a.HEAP16=ra=new Int16Array(b);a.HEAP32=u=new Int32Array(b);a.HEAPU8=y=new Uint8Array(b);a.HEAPU16=new Uint16Array(b);a.HEAPU32=new Uint32Array(b);a.HEAPF32=ta=new Float32Array(b);a.HEAPF64=ua=new Float64Array(b)}var Ca,Da=[],Fa=[],Ga=[];function Ha(){var b=a.preRun.shift();Da.unshift(b)}var B=0,Ia=null,Ja=null;a.preloadedImages={};a.preloadedAudios={};
function q(b){if(a.onAbort)a.onAbort(b);pa(b);xa=!0;b=new WebAssembly.RuntimeError("abort("+b+"). Build with -s ASSERTIONS=1 for more info.");ba(b);throw b;}function Ka(){return C.startsWith("data:application/octet-stream;base64,")}var C;C="olm.wasm";if(!Ka()){var La=C;C=a.locateFile?a.locateFile(La,n):n+La}function Ma(){var b=C;try{if(b==C&&qa)return new Uint8Array(qa);if(ma)return ma(b);throw"both async and sync fetching of the wasm failed";}catch(c){q(c)}}
function Na(){if(!qa&&(ha||m)){if("function"===typeof fetch&&!C.startsWith("file://"))return fetch(C,{credentials:"same-origin"}).then(function(b){if(!b.ok)throw"failed to load wasm binary file at '"+C+"'";return b.arrayBuffer()}).catch(function(){return Ma()});if(la)return new Promise(function(b,c){la(C,function(d){b(new Uint8Array(d))},c)})}return Promise.resolve().then(function(){return Ma()})}var w,sa;
function Oa(b){for(;0<b.length;){var c=b.shift();if("function"==typeof c)c(a);else{var d=c.Rb;"number"===typeof d?void 0===c.Qb?Ca.get(d)():Ca.get(d)(c.Qb):d(void 0===c.Qb?null:c.Qb)}}}
var Pa={c:function(b,c,d,e){q("Assertion failed: "+x(b)+", at: "+[c?x(c):"unknown filename",d,e?x(e):"unknown function"])},a:function(b,c,d){y.copyWithin(b,c,c+d)},b:function(b){var c=y.length;b>>>=0;if(2147483648<b)return!1;for(var d=1;4>=d;d*=2){var e=c*(1+.2/d);e=Math.min(e,b+100663296);e=Math.max(b,e);0<e%65536&&(e+=65536-e%65536);a:{try{wa.grow(Math.min(2147483648,e)-Aa.byteLength+65535>>>16);Ba();var f=1;break a}catch(k){}f=void 0}if(f)return!0}return!1}};
(function(){function b(f){a.asm=f.exports;wa=a.asm.d;Ba();Ca=a.asm.f;Fa.unshift(a.asm.e);B--;a.monitorRunDependencies&&a.monitorRunDependencies(B);0==B&&(null!==Ia&&(clearInterval(Ia),Ia=null),Ja&&(f=Ja,Ja=null,f()))}function c(f){b(f.instance)}function d(f){return Na().then(function(k){return WebAssembly.instantiate(k,e)}).then(f,function(k){pa("failed to asynchronously prepare wasm: "+k);q(k)})}var e={a:Pa};B++;a.monitorRunDependencies&&a.monitorRunDependencies(B);if(a.instantiateWasm)try{return a.instantiateWasm(e,
b)}catch(f){return pa("Module.instantiateWasm callback failed with error: "+f),!1}(function(){return qa||"function"!==typeof WebAssembly.instantiateStreaming||Ka()||C.startsWith("file://")||"function"!==typeof fetch?d(c):fetch(C,{credentials:"same-origin"}).then(function(f){return WebAssembly.instantiateStreaming(f,e).then(c,function(k){pa("wasm streaming compile failed: "+k);pa("falling back to ArrayBuffer instantiation");return d(c)})})})().catch(ba);return{}})();
a.___wasm_call_ctors=function(){return(a.___wasm_call_ctors=a.asm.e).apply(null,arguments)};a._olm_get_library_version=function(){return(a._olm_get_library_version=a.asm.g).apply(null,arguments)};a._olm_error=function(){return(a._olm_error=a.asm.h).apply(null,arguments)};a._olm_account_last_error=function(){return(a._olm_account_last_error=a.asm.i).apply(null,arguments)};a._olm_session_last_error=function(){return(a._olm_session_last_error=a.asm.j).apply(null,arguments)};
a._olm_utility_last_error=function(){return(a._olm_utility_last_error=a.asm.k).apply(null,arguments)};a._olm_account_size=function(){return(a._olm_account_size=a.asm.l).apply(null,arguments)};a._olm_session_size=function(){return(a._olm_session_size=a.asm.m).apply(null,arguments)};a._olm_utility_size=function(){return(a._olm_utility_size=a.asm.n).apply(null,arguments)};a._olm_account=function(){return(a._olm_account=a.asm.o).apply(null,arguments)};
a._olm_session=function(){return(a._olm_session=a.asm.p).apply(null,arguments)};a._olm_utility=function(){return(a._olm_utility=a.asm.q).apply(null,arguments)};a._olm_clear_account=function(){return(a._olm_clear_account=a.asm.r).apply(null,arguments)};a._olm_clear_session=function(){return(a._olm_clear_session=a.asm.s).apply(null,arguments)};a._olm_clear_utility=function(){return(a._olm_clear_utility=a.asm.t).apply(null,arguments)};
a._olm_pickle_account_length=function(){return(a._olm_pickle_account_length=a.asm.u).apply(null,arguments)};a._olm_pickle_session_length=function(){return(a._olm_pickle_session_length=a.asm.v).apply(null,arguments)};a._olm_pickle_account=function(){return(a._olm_pickle_account=a.asm.w).apply(null,arguments)};a._olm_pickle_session=function(){return(a._olm_pickle_session=a.asm.x).apply(null,arguments)};a._olm_unpickle_account=function(){return(a._olm_unpickle_account=a.asm.y).apply(null,arguments)};
a._olm_unpickle_session=function(){return(a._olm_unpickle_session=a.asm.z).apply(null,arguments)};a._olm_create_account_random_length=function(){return(a._olm_create_account_random_length=a.asm.A).apply(null,arguments)};a._olm_create_account=function(){return(a._olm_create_account=a.asm.B).apply(null,arguments)};a._olm_account_identity_keys_length=function(){return(a._olm_account_identity_keys_length=a.asm.C).apply(null,arguments)};
a._olm_account_identity_keys=function(){return(a._olm_account_identity_keys=a.asm.D).apply(null,arguments)};a._olm_account_signature_length=function(){return(a._olm_account_signature_length=a.asm.E).apply(null,arguments)};a._olm_account_sign=function(){return(a._olm_account_sign=a.asm.F).apply(null,arguments)};a._olm_account_one_time_keys_length=function(){return(a._olm_account_one_time_keys_length=a.asm.G).apply(null,arguments)};
a._olm_account_one_time_keys=function(){return(a._olm_account_one_time_keys=a.asm.H).apply(null,arguments)};a._olm_account_mark_keys_as_published=function(){return(a._olm_account_mark_keys_as_published=a.asm.I).apply(null,arguments)};a._olm_account_max_number_of_one_time_keys=function(){return(a._olm_account_max_number_of_one_time_keys=a.asm.J).apply(null,arguments)};
a._olm_account_generate_one_time_keys_random_length=function(){return(a._olm_account_generate_one_time_keys_random_length=a.asm.K).apply(null,arguments)};a._olm_account_generate_one_time_keys=function(){return(a._olm_account_generate_one_time_keys=a.asm.L).apply(null,arguments)};a._olm_account_generate_fallback_key_random_length=function(){return(a._olm_account_generate_fallback_key_random_length=a.asm.M).apply(null,arguments)};
a._olm_account_generate_fallback_key=function(){return(a._olm_account_generate_fallback_key=a.asm.N).apply(null,arguments)};a._olm_account_fallback_key_length=function(){return(a._olm_account_fallback_key_length=a.asm.O).apply(null,arguments)};a._olm_account_fallback_key=function(){return(a._olm_account_fallback_key=a.asm.P).apply(null,arguments)};a._olm_create_outbound_session_random_length=function(){return(a._olm_create_outbound_session_random_length=a.asm.Q).apply(null,arguments)};
a._olm_create_outbound_session=function(){return(a._olm_create_outbound_session=a.asm.R).apply(null,arguments)};a._olm_create_inbound_session=function(){return(a._olm_create_inbound_session=a.asm.S).apply(null,arguments)};a._olm_create_inbound_session_from=function(){return(a._olm_create_inbound_session_from=a.asm.T).apply(null,arguments)};a._olm_session_id_length=function(){return(a._olm_session_id_length=a.asm.U).apply(null,arguments)};
a._olm_session_id=function(){return(a._olm_session_id=a.asm.V).apply(null,arguments)};a._olm_session_has_received_message=function(){return(a._olm_session_has_received_message=a.asm.W).apply(null,arguments)};a._olm_session_describe=function(){return(a._olm_session_describe=a.asm.X).apply(null,arguments)};a._olm_matches_inbound_session=function(){return(a._olm_matches_inbound_session=a.asm.Y).apply(null,arguments)};
a._olm_matches_inbound_session_from=function(){return(a._olm_matches_inbound_session_from=a.asm.Z).apply(null,arguments)};a._olm_remove_one_time_keys=function(){return(a._olm_remove_one_time_keys=a.asm._).apply(null,arguments)};a._olm_encrypt_message_type=function(){return(a._olm_encrypt_message_type=a.asm.$).apply(null,arguments)};a._olm_encrypt_random_length=function(){return(a._olm_encrypt_random_length=a.asm.aa).apply(null,arguments)};
a._olm_encrypt_message_length=function(){return(a._olm_encrypt_message_length=a.asm.ba).apply(null,arguments)};a._olm_encrypt=function(){return(a._olm_encrypt=a.asm.ca).apply(null,arguments)};a._olm_decrypt_max_plaintext_length=function(){return(a._olm_decrypt_max_plaintext_length=a.asm.da).apply(null,arguments)};a._olm_decrypt=function(){return(a._olm_decrypt=a.asm.ea).apply(null,arguments)};a._olm_sha256_length=function(){return(a._olm_sha256_length=a.asm.fa).apply(null,arguments)};
a._olm_sha256=function(){return(a._olm_sha256=a.asm.ga).apply(null,arguments)};a._olm_ed25519_verify=function(){return(a._olm_ed25519_verify=a.asm.ha).apply(null,arguments)};a._olm_pk_encryption_last_error=function(){return(a._olm_pk_encryption_last_error=a.asm.ia).apply(null,arguments)};a._olm_pk_encryption_size=function(){return(a._olm_pk_encryption_size=a.asm.ja).apply(null,arguments)};a._olm_pk_encryption=function(){return(a._olm_pk_encryption=a.asm.ka).apply(null,arguments)};
a._olm_clear_pk_encryption=function(){return(a._olm_clear_pk_encryption=a.asm.la).apply(null,arguments)};a._olm_pk_encryption_set_recipient_key=function(){return(a._olm_pk_encryption_set_recipient_key=a.asm.ma).apply(null,arguments)};a._olm_pk_key_length=function(){return(a._olm_pk_key_length=a.asm.na).apply(null,arguments)};a._olm_pk_ciphertext_length=function(){return(a._olm_pk_ciphertext_length=a.asm.oa).apply(null,arguments)};
a._olm_pk_mac_length=function(){return(a._olm_pk_mac_length=a.asm.pa).apply(null,arguments)};a._olm_pk_encrypt_random_length=function(){return(a._olm_pk_encrypt_random_length=a.asm.qa).apply(null,arguments)};a._olm_pk_encrypt=function(){return(a._olm_pk_encrypt=a.asm.ra).apply(null,arguments)};a._olm_pk_decryption_last_error=function(){return(a._olm_pk_decryption_last_error=a.asm.sa).apply(null,arguments)};
a._olm_pk_decryption_size=function(){return(a._olm_pk_decryption_size=a.asm.ta).apply(null,arguments)};a._olm_pk_decryption=function(){return(a._olm_pk_decryption=a.asm.ua).apply(null,arguments)};a._olm_clear_pk_decryption=function(){return(a._olm_clear_pk_decryption=a.asm.va).apply(null,arguments)};a._olm_pk_private_key_length=function(){return(a._olm_pk_private_key_length=a.asm.wa).apply(null,arguments)};
a._olm_pk_generate_key_random_length=function(){return(a._olm_pk_generate_key_random_length=a.asm.xa).apply(null,arguments)};a._olm_pk_key_from_private=function(){return(a._olm_pk_key_from_private=a.asm.ya).apply(null,arguments)};a._olm_pk_generate_key=function(){return(a._olm_pk_generate_key=a.asm.za).apply(null,arguments)};a._olm_pickle_pk_decryption_length=function(){return(a._olm_pickle_pk_decryption_length=a.asm.Aa).apply(null,arguments)};
a._olm_pickle_pk_decryption=function(){return(a._olm_pickle_pk_decryption=a.asm.Ba).apply(null,arguments)};a._olm_unpickle_pk_decryption=function(){return(a._olm_unpickle_pk_decryption=a.asm.Ca).apply(null,arguments)};a._olm_pk_max_plaintext_length=function(){return(a._olm_pk_max_plaintext_length=a.asm.Da).apply(null,arguments)};a._olm_pk_decrypt=function(){return(a._olm_pk_decrypt=a.asm.Ea).apply(null,arguments)};
a._olm_pk_get_private_key=function(){return(a._olm_pk_get_private_key=a.asm.Fa).apply(null,arguments)};a._olm_pk_signing_size=function(){return(a._olm_pk_signing_size=a.asm.Ga).apply(null,arguments)};a._olm_pk_signing=function(){return(a._olm_pk_signing=a.asm.Ha).apply(null,arguments)};a._olm_pk_signing_last_error=function(){return(a._olm_pk_signing_last_error=a.asm.Ia).apply(null,arguments)};a._olm_clear_pk_signing=function(){return(a._olm_clear_pk_signing=a.asm.Ja).apply(null,arguments)};
a._olm_pk_signing_seed_length=function(){return(a._olm_pk_signing_seed_length=a.asm.Ka).apply(null,arguments)};a._olm_pk_signing_public_key_length=function(){return(a._olm_pk_signing_public_key_length=a.asm.La).apply(null,arguments)};a._olm_pk_signing_key_from_seed=function(){return(a._olm_pk_signing_key_from_seed=a.asm.Ma).apply(null,arguments)};a._olm_pk_signature_length=function(){return(a._olm_pk_signature_length=a.asm.Na).apply(null,arguments)};
a._olm_pk_sign=function(){return(a._olm_pk_sign=a.asm.Oa).apply(null,arguments)};a._olm_inbound_group_session_size=function(){return(a._olm_inbound_group_session_size=a.asm.Pa).apply(null,arguments)};a._olm_inbound_group_session=function(){return(a._olm_inbound_group_session=a.asm.Qa).apply(null,arguments)};a._olm_clear_inbound_group_session=function(){return(a._olm_clear_inbound_group_session=a.asm.Ra).apply(null,arguments)};
a._olm_inbound_group_session_last_error=function(){return(a._olm_inbound_group_session_last_error=a.asm.Sa).apply(null,arguments)};a._olm_init_inbound_group_session=function(){return(a._olm_init_inbound_group_session=a.asm.Ta).apply(null,arguments)};a._olm_import_inbound_group_session=function(){return(a._olm_import_inbound_group_session=a.asm.Ua).apply(null,arguments)};a._olm_pickle_inbound_group_session_length=function(){return(a._olm_pickle_inbound_group_session_length=a.asm.Va).apply(null,arguments)};
a._olm_pickle_inbound_group_session=function(){return(a._olm_pickle_inbound_group_session=a.asm.Wa).apply(null,arguments)};a._olm_unpickle_inbound_group_session=function(){return(a._olm_unpickle_inbound_group_session=a.asm.Xa).apply(null,arguments)};a._olm_group_decrypt_max_plaintext_length=function(){return(a._olm_group_decrypt_max_plaintext_length=a.asm.Ya).apply(null,arguments)};a._olm_group_decrypt=function(){return(a._olm_group_decrypt=a.asm.Za).apply(null,arguments)};
a._olm_inbound_group_session_id_length=function(){return(a._olm_inbound_group_session_id_length=a.asm._a).apply(null,arguments)};a._olm_inbound_group_session_id=function(){return(a._olm_inbound_group_session_id=a.asm.$a).apply(null,arguments)};a._olm_inbound_group_session_first_known_index=function(){return(a._olm_inbound_group_session_first_known_index=a.asm.ab).apply(null,arguments)};
a._olm_inbound_group_session_is_verified=function(){return(a._olm_inbound_group_session_is_verified=a.asm.bb).apply(null,arguments)};a._olm_export_inbound_group_session_length=function(){return(a._olm_export_inbound_group_session_length=a.asm.cb).apply(null,arguments)};a._olm_export_inbound_group_session=function(){return(a._olm_export_inbound_group_session=a.asm.db).apply(null,arguments)};
a._olm_outbound_group_session_size=function(){return(a._olm_outbound_group_session_size=a.asm.eb).apply(null,arguments)};a._olm_outbound_group_session=function(){return(a._olm_outbound_group_session=a.asm.fb).apply(null,arguments)};a._olm_clear_outbound_group_session=function(){return(a._olm_clear_outbound_group_session=a.asm.gb).apply(null,arguments)};a._olm_outbound_group_session_last_error=function(){return(a._olm_outbound_group_session_last_error=a.asm.hb).apply(null,arguments)};
a._olm_pickle_outbound_group_session_length=function(){return(a._olm_pickle_outbound_group_session_length=a.asm.ib).apply(null,arguments)};a._olm_pickle_outbound_group_session=function(){return(a._olm_pickle_outbound_group_session=a.asm.jb).apply(null,arguments)};a._olm_unpickle_outbound_group_session=function(){return(a._olm_unpickle_outbound_group_session=a.asm.kb).apply(null,arguments)};
a._olm_init_outbound_group_session_random_length=function(){return(a._olm_init_outbound_group_session_random_length=a.asm.lb).apply(null,arguments)};a._olm_init_outbound_group_session=function(){return(a._olm_init_outbound_group_session=a.asm.mb).apply(null,arguments)};a._olm_group_encrypt_message_length=function(){return(a._olm_group_encrypt_message_length=a.asm.nb).apply(null,arguments)};a._olm_group_encrypt=function(){return(a._olm_group_encrypt=a.asm.ob).apply(null,arguments)};
a._olm_outbound_group_session_id_length=function(){return(a._olm_outbound_group_session_id_length=a.asm.pb).apply(null,arguments)};a._olm_outbound_group_session_id=function(){return(a._olm_outbound_group_session_id=a.asm.qb).apply(null,arguments)};a._olm_outbound_group_session_message_index=function(){return(a._olm_outbound_group_session_message_index=a.asm.rb).apply(null,arguments)};
a._olm_outbound_group_session_key_length=function(){return(a._olm_outbound_group_session_key_length=a.asm.sb).apply(null,arguments)};a._olm_outbound_group_session_key=function(){return(a._olm_outbound_group_session_key=a.asm.tb).apply(null,arguments)};a._olm_sas_last_error=function(){return(a._olm_sas_last_error=a.asm.ub).apply(null,arguments)};a._olm_sas_size=function(){return(a._olm_sas_size=a.asm.vb).apply(null,arguments)};a._olm_sas=function(){return(a._olm_sas=a.asm.wb).apply(null,arguments)};
a._olm_clear_sas=function(){return(a._olm_clear_sas=a.asm.xb).apply(null,arguments)};a._olm_create_sas_random_length=function(){return(a._olm_create_sas_random_length=a.asm.yb).apply(null,arguments)};a._olm_create_sas=function(){return(a._olm_create_sas=a.asm.zb).apply(null,arguments)};a._olm_sas_pubkey_length=function(){return(a._olm_sas_pubkey_length=a.asm.Ab).apply(null,arguments)};a._olm_sas_get_pubkey=function(){return(a._olm_sas_get_pubkey=a.asm.Bb).apply(null,arguments)};
a._olm_sas_set_their_key=function(){return(a._olm_sas_set_their_key=a.asm.Cb).apply(null,arguments)};a._olm_sas_is_their_key_set=function(){return(a._olm_sas_is_their_key_set=a.asm.Db).apply(null,arguments)};a._olm_sas_generate_bytes=function(){return(a._olm_sas_generate_bytes=a.asm.Eb).apply(null,arguments)};a._olm_sas_mac_length=function(){return(a._olm_sas_mac_length=a.asm.Fb).apply(null,arguments)};
a._olm_sas_calculate_mac_fixed_base64=function(){return(a._olm_sas_calculate_mac_fixed_base64=a.asm.Gb).apply(null,arguments)};a._olm_sas_calculate_mac=function(){return(a._olm_sas_calculate_mac=a.asm.Hb).apply(null,arguments)};a._olm_sas_calculate_mac_long_kdf=function(){return(a._olm_sas_calculate_mac_long_kdf=a.asm.Ib).apply(null,arguments)};a._malloc=function(){return(a._malloc=a.asm.Jb).apply(null,arguments)};a._free=function(){return(a._free=a.asm.Kb).apply(null,arguments)};
var Qa=a.stackSave=function(){return(Qa=a.stackSave=a.asm.Lb).apply(null,arguments)},Ra=a.stackRestore=function(){return(Ra=a.stackRestore=a.asm.Mb).apply(null,arguments)},Sa=a.stackAlloc=function(){return(Sa=a.stackAlloc=a.asm.Nb).apply(null,arguments)};a.ALLOC_STACK=1;var Ta;Ja=function Ua(){Ta||Va();Ta||(Ja=Ua)};
function Va(){function b(){if(!Ta&&(Ta=!0,a.calledRun=!0,!xa)){Oa(Fa);aa(a);if(a.onRuntimeInitialized)a.onRuntimeInitialized();if(a.postRun)for("function"==typeof a.postRun&&(a.postRun=[a.postRun]);a.postRun.length;){var c=a.postRun.shift();Ga.unshift(c)}Oa(Ga)}}if(!(0<B)){if(a.preRun)for("function"==typeof a.preRun&&(a.preRun=[a.preRun]);a.preRun.length;)Ha();Oa(Da);0<B||(a.setStatus?(a.setStatus("Running..."),setTimeout(function(){setTimeout(function(){a.setStatus("")},1);b()},1)):b())}}a.run=Va;
if(a.preInit)for("function"==typeof a.preInit&&(a.preInit=[a.preInit]);0<a.preInit.length;)a.preInit.pop()();Va();function D(){var b=a._olm_outbound_group_session_size();this.Pb=E(b);this.Ob=a._olm_outbound_group_session(this.Pb)}function F(b){return function(){var c=b.apply(this,arguments);if(c===h)throw c=x(a._olm_outbound_group_session_last_error(arguments[0])),Error("OLM."+c);return c}}D.prototype.free=function(){a._olm_clear_outbound_group_session(this.Ob);G(this.Ob)};
D.prototype.pickle=I(function(b){b=J(b);var c=F(a._olm_pickle_outbound_group_session_length)(this.Ob),d=K(b),e=K(c+1);try{F(a._olm_pickle_outbound_group_session)(this.Ob,d,b.length,e,c)}finally{for(L(d,b.length),d=0;d<b.length;d++)b[d]=0}return x(e,c)});D.prototype.unpickle=I(function(b,c){b=J(b);var d=K(b);c=J(c);var e=K(c);try{F(a._olm_unpickle_outbound_group_session)(this.Ob,d,b.length,e,c.length)}finally{for(L(d,b.length),d=0;d<b.length;d++)b[d]=0}});
D.prototype.create=I(function(){var b=F(a._olm_init_outbound_group_session_random_length)(this.Ob),c=M(b,g);F(a._olm_init_outbound_group_session)(this.Ob,c,b)});D.prototype.encrypt=function(b){try{var c=A(b);var d=F(a._olm_group_encrypt_message_length)(this.Ob,c);var e=E(c+1);z(b,y,e,c+1);var f=E(d+1);F(a._olm_group_encrypt)(this.Ob,e,c,f,d);r(f+d);return x(f,d)}finally{void 0!==e&&(L(e,c+1),G(e)),void 0!==f&&G(f)}};
D.prototype.session_id=I(function(){var b=F(a._olm_outbound_group_session_id_length)(this.Ob),c=K(b+1);F(a._olm_outbound_group_session_id)(this.Ob,c,b);return x(c,b)});D.prototype.session_key=I(function(){var b=F(a._olm_outbound_group_session_key_length)(this.Ob),c=K(b+1);F(a._olm_outbound_group_session_key)(this.Ob,c,b);var d=x(c,b);L(c,b);return d});D.prototype.message_index=function(){return F(a._olm_outbound_group_session_message_index)(this.Ob)};olm_exports.OutboundGroupSession=D;
function N(){var b=a._olm_inbound_group_session_size();this.Pb=E(b);this.Ob=a._olm_inbound_group_session(this.Pb)}function O(b){return function(){var c=b.apply(this,arguments);if(c===h)throw c=x(a._olm_inbound_group_session_last_error(arguments[0])),Error("OLM."+c);return c}}N.prototype.free=function(){a._olm_clear_inbound_group_session(this.Ob);G(this.Ob)};
N.prototype.pickle=I(function(b){b=J(b);var c=O(a._olm_pickle_inbound_group_session_length)(this.Ob),d=K(b),e=K(c+1);try{O(a._olm_pickle_inbound_group_session)(this.Ob,d,b.length,e,c)}finally{for(L(d,b.length),d=0;d<b.length;d++)b[d]=0}return x(e,c)});N.prototype.unpickle=I(function(b,c){b=J(b);var d=K(b);c=J(c);var e=K(c);try{O(a._olm_unpickle_inbound_group_session)(this.Ob,d,b.length,e,c.length)}finally{for(L(d,b.length),d=0;d<b.length;d++)b[d]=0}});
N.prototype.create=I(function(b){b=J(b);var c=K(b);try{O(a._olm_init_inbound_group_session)(this.Ob,c,b.length)}finally{for(L(c,b.length),c=0;c<b.length;c++)b[c]=0}});N.prototype.import_session=I(function(b){b=J(b);var c=K(b);try{O(a._olm_import_inbound_group_session)(this.Ob,c,b.length)}finally{for(L(c,b.length),c=0;c<b.length;c++)b[c]=0}});
N.prototype.decrypt=I(function(b){try{var c=E(b.length);za(b,c);var d=O(a._olm_group_decrypt_max_plaintext_length)(this.Ob,c,b.length);za(b,c);var e=E(d+1);var f=K(4);var k=O(a._olm_group_decrypt)(this.Ob,c,b.length,e,d,f);r(e+k);return{plaintext:x(e,k),message_index:va(f,"i32")}}finally{void 0!==c&&G(c),void 0!==e&&(L(e,k),G(e))}});N.prototype.session_id=I(function(){var b=O(a._olm_inbound_group_session_id_length)(this.Ob),c=K(b+1);O(a._olm_inbound_group_session_id)(this.Ob,c,b);return x(c,b)});
N.prototype.first_known_index=I(function(){return O(a._olm_inbound_group_session_first_known_index)(this.Ob)});N.prototype.export_session=I(function(b){var c=O(a._olm_export_inbound_group_session_length)(this.Ob),d=K(c+1);F(a._olm_export_inbound_group_session)(this.Ob,d,c,b);b=x(d,c);L(d,c);return b});olm_exports.InboundGroupSession=N;function Wa(){var b=a._olm_pk_encryption_size();this.Pb=E(b);this.Ob=a._olm_pk_encryption(this.Pb)}
function P(b){return function(){var c=b.apply(this,arguments);if(c===h)throw c=x(a._olm_pk_encryption_last_error(arguments[0])),Error("OLM."+c);return c}}Wa.prototype.free=function(){a._olm_clear_pk_encryption(this.Ob);G(this.Ob)};Wa.prototype.set_recipient_key=I(function(b){b=J(b);var c=K(b);P(a._olm_pk_encryption_set_recipient_key)(this.Ob,c,b.length)});
Wa.prototype.encrypt=I(function(b){try{var c=A(b);var d=E(c+1);z(b,y,d,c+1);var e=P(a._olm_pk_encrypt_random_length)();var f=M(e,g);var k=P(a._olm_pk_ciphertext_length)(this.Ob,c);var p=E(k+1);var v=P(a._olm_pk_mac_length)(this.Ob),fa=K(v+1);r(fa+v);var T=P(a._olm_pk_key_length)(),H=K(T+1);r(H+T);P(a._olm_pk_encrypt)(this.Ob,d,c,p,k,fa,v,H,T,f,e);r(p+k);return{ciphertext:x(p,k),mac:x(fa,v),ephemeral:x(H,T)}}finally{void 0!==f&&L(f,e),void 0!==d&&(L(d,c+1),G(d)),void 0!==p&&G(p)}});
function Q(){var b=a._olm_pk_decryption_size();this.Pb=E(b);this.Ob=a._olm_pk_decryption(this.Pb)}function R(b){return function(){var c=b.apply(this,arguments);if(c===h)throw c=x(a._olm_pk_decryption_last_error(arguments[0])),Error("OLM."+c);return c}}Q.prototype.free=function(){a._olm_clear_pk_decryption(this.Ob);G(this.Ob)};
Q.prototype.init_with_private_key=I(function(b){var c=K(b.length);a.HEAPU8.set(b,c);var d=R(a._olm_pk_key_length)(),e=K(d+1);try{R(a._olm_pk_key_from_private)(this.Ob,e,d,c,b.length)}finally{L(c,b.length)}return x(e,d)});Q.prototype.generate_key=I(function(){var b=R(a._olm_pk_private_key_length)(),c=M(b,g),d=R(a._olm_pk_key_length)(),e=K(d+1);try{R(a._olm_pk_key_from_private)(this.Ob,e,d,c,b)}finally{L(c,b)}return x(e,d)});
Q.prototype.get_private_key=I(function(){var b=P(a._olm_pk_private_key_length)(),c=K(b);R(a._olm_pk_get_private_key)(this.Ob,c,b);var d=new Uint8Array(new Uint8Array(a.HEAPU8.buffer,c,b));L(c,b);return d});Q.prototype.pickle=I(function(b){b=J(b);var c=R(a._olm_pickle_pk_decryption_length)(this.Ob),d=K(b),e=K(c+1);try{R(a._olm_pickle_pk_decryption)(this.Ob,d,b.length,e,c)}finally{for(L(d,b.length),d=0;d<b.length;d++)b[d]=0}return x(e,c)});
Q.prototype.unpickle=I(function(b,c){b=J(b);var d=K(b),e=J(c),f=K(e);c=R(a._olm_pk_key_length)();var k=K(c+1);try{R(a._olm_unpickle_pk_decryption)(this.Ob,d,b.length,f,e.length,k,c)}finally{for(L(d,b.length),d=0;d<b.length;d++)b[d]=0}return x(k,c)});
Q.prototype.decrypt=I(function(b,c,d){try{var e=A(d);var f=E(e+1);z(d,y,f,e+1);var k=J(b),p=K(k),v=J(c),fa=K(v);var T=R(a._olm_pk_max_plaintext_length)(this.Ob,e);var H=E(T+1);var Ea=R(a._olm_pk_decrypt)(this.Ob,p,k.length,fa,v.length,f,e,H,T);r(H+Ea);return x(H,Ea)}finally{void 0!==H&&(L(H,Ea+1),G(H)),void 0!==f&&G(f)}});function Xa(){var b=a._olm_pk_signing_size();this.Pb=E(b);this.Ob=a._olm_pk_signing(this.Pb)}
function Ya(b){return function(){var c=b.apply(this,arguments);if(c===h)throw c=x(a._olm_pk_signing_last_error(arguments[0])),Error("OLM."+c);return c}}Xa.prototype.free=function(){a._olm_clear_pk_signing(this.Ob);G(this.Ob)};Xa.prototype.init_with_seed=I(function(b){var c=K(b.length);a.HEAPU8.set(b,c);var d=Ya(a._olm_pk_signing_public_key_length)(),e=K(d+1);try{Ya(a._olm_pk_signing_key_from_seed)(this.Ob,e,d,c,b.length)}finally{L(c,b.length)}return x(e,d)});
Xa.prototype.generate_seed=I(function(){var b=Ya(a._olm_pk_signing_seed_length)(),c=M(b,g),d=new Uint8Array(new Uint8Array(a.HEAPU8.buffer,c,b));L(c,b);return d});Xa.prototype.sign=I(function(b){try{var c=A(b);var d=E(c+1);z(b,y,d,c+1);var e=Ya(a._olm_pk_signature_length)(),f=K(e+1);Ya(a._olm_pk_sign)(this.Ob,d,c,f,e);return x(f,e)}finally{void 0!==d&&(L(d,c+1),G(d))}});
function S(){var b=a._olm_sas_size(),c=a._olm_create_sas_random_length(),d=M(c,g);this.Pb=E(b);this.Ob=a._olm_sas(this.Pb);a._olm_create_sas(this.Ob,d,c);L(d,c)}function U(b){return function(){var c=b.apply(this,arguments);if(c===h)throw c=x(a._olm_sas_last_error(arguments[0])),Error("OLM."+c);return c}}S.prototype.free=function(){a._olm_clear_sas(this.Ob);G(this.Ob)};
S.prototype.get_pubkey=I(function(){var b=U(a._olm_sas_pubkey_length)(this.Ob),c=K(b+1);U(a._olm_sas_get_pubkey)(this.Ob,c,b);return x(c,b)});S.prototype.set_their_key=I(function(b){b=J(b);var c=K(b);U(a._olm_sas_set_their_key)(this.Ob,c,b.length)});S.prototype.is_their_key_set=I(function(){return U(a._olm_sas_is_their_key_set)(this.Ob)?!0:!1});
S.prototype.generate_bytes=I(function(b,c){b=J(b);var d=K(b),e=K(c);U(a._olm_sas_generate_bytes)(this.Ob,d,b.length,e,c);return new Uint8Array(new Uint8Array(a.HEAPU8.buffer,e,c))});S.prototype.calculate_mac=I(function(b,c){b=J(b);var d=K(b);c=J(c);var e=K(c),f=U(a._olm_sas_mac_length)(this.Ob),k=K(f+1);U(a._olm_sas_calculate_mac)(this.Ob,d,b.length,e,c.length,k,f);return x(k,f)});
S.prototype.calculate_mac_long_kdf=I(function(b,c){b=J(b);var d=K(b);c=J(c);var e=K(c),f=U(a._olm_sas_mac_length)(this.Ob),k=K(f+1);U(a._olm_sas_calculate_mac_long_kdf)(this.Ob,d,b.length,e,c.length,k,f);return x(k,f)});var E=a._malloc,G=a._free,h;function M(b,c){var d=Sa(b);c(new Uint8Array(a.HEAPU8.buffer,d,b));return d}function K(b){return"number"==typeof b?M(b,function(c){c.fill(0)}):M(b.length,function(c){c.set(b)})}
function J(b){if(b instanceof Uint8Array)var c=b;else c=Array(A(b)+1),b=z(b,c,0,c.length),c.length=b;return c}function I(b){return function(){var c=Qa();try{return b.apply(this,arguments)}finally{Ra(c)}}}function L(b,c){for(;0<c--;)a.HEAP8[b++]=0}function V(){var b=a._olm_account_size();this.Pb=E(b);this.Ob=a._olm_account(this.Pb)}function W(b){return function(){var c=b.apply(this,arguments);if(c===h)throw c=x(a._olm_account_last_error(arguments[0])),Error("OLM."+c);return c}}
V.prototype.free=function(){a._olm_clear_account(this.Ob);G(this.Ob)};V.prototype.create=I(function(){var b=W(a._olm_create_account_random_length)(this.Ob),c=M(b,g);W(a._olm_create_account)(this.Ob,c,b)});V.prototype.identity_keys=I(function(){var b=W(a._olm_account_identity_keys_length)(this.Ob),c=K(b+1);W(a._olm_account_identity_keys)(this.Ob,c,b);return x(c,b)});
V.prototype.sign=I(function(b){var c=W(a._olm_account_signature_length)(this.Ob);b=J(b);var d=K(b),e=K(c+1);try{W(a._olm_account_sign)(this.Ob,d,b.length,e,c)}finally{for(L(d,b.length),d=0;d<b.length;d++)b[d]=0}return x(e,c)});V.prototype.one_time_keys=I(function(){var b=W(a._olm_account_one_time_keys_length)(this.Ob),c=K(b+1);W(a._olm_account_one_time_keys)(this.Ob,c,b);return x(c,b)});V.prototype.mark_keys_as_published=I(function(){W(a._olm_account_mark_keys_as_published)(this.Ob)});
V.prototype.max_number_of_one_time_keys=I(function(){return W(a._olm_account_max_number_of_one_time_keys)(this.Ob)});V.prototype.generate_one_time_keys=I(function(b){var c=W(a._olm_account_generate_one_time_keys_random_length)(this.Ob,b),d=M(c,g);W(a._olm_account_generate_one_time_keys)(this.Ob,b,d,c)});V.prototype.remove_one_time_keys=I(function(b){W(a._olm_remove_one_time_keys)(this.Ob,b.Ob)});
V.prototype.generate_fallback_key=I(function(){var b=W(a._olm_account_generate_fallback_key_random_length)(this.Ob),c=M(b,g);W(a._olm_account_generate_fallback_key)(this.Ob,c,b)});V.prototype.fallback_key=I(function(){var b=W(a._olm_account_fallback_key_length)(this.Ob),c=K(b+1);W(a._olm_account_fallback_key)(this.Ob,c,b);return x(c,b)});
V.prototype.pickle=I(function(b){b=J(b);var c=W(a._olm_pickle_account_length)(this.Ob),d=K(b),e=K(c+1);try{W(a._olm_pickle_account)(this.Ob,d,b.length,e,c)}finally{for(L(d,b.length),d=0;d<b.length;d++)b[d]=0}return x(e,c)});V.prototype.unpickle=I(function(b,c){b=J(b);var d=K(b);c=J(c);var e=K(c);try{W(a._olm_unpickle_account)(this.Ob,d,b.length,e,c.length)}finally{for(L(d,b.length),d=0;d<b.length;d++)b[d]=0}});function X(){var b=a._olm_session_size();this.Pb=E(b);this.Ob=a._olm_session(this.Pb)}
function Y(b){return function(){var c=b.apply(this,arguments);if(c===h)throw c=x(a._olm_session_last_error(arguments[0])),Error("OLM."+c);return c}}X.prototype.free=function(){a._olm_clear_session(this.Ob);G(this.Ob)};X.prototype.pickle=I(function(b){b=J(b);var c=Y(a._olm_pickle_session_length)(this.Ob),d=K(b),e=K(c+1);try{Y(a._olm_pickle_session)(this.Ob,d,b.length,e,c)}finally{for(L(d,b.length),d=0;d<b.length;d++)b[d]=0}return x(e,c)});
X.prototype.unpickle=I(function(b,c){b=J(b);var d=K(b);c=J(c);var e=K(c);try{Y(a._olm_unpickle_session)(this.Ob,d,b.length,e,c.length)}finally{for(L(d,b.length),d=0;d<b.length;d++)b[d]=0}});X.prototype.create_outbound=I(function(b,c,d){var e=Y(a._olm_create_outbound_session_random_length)(this.Ob),f=M(e,g);c=J(c);d=J(d);var k=K(c),p=K(d);try{Y(a._olm_create_outbound_session)(this.Ob,b.Ob,k,c.length,p,d.length,f,e)}finally{L(f,e)}});
X.prototype.create_inbound=I(function(b,c){c=J(c);var d=K(c);try{Y(a._olm_create_inbound_session)(this.Ob,b.Ob,d,c.length)}finally{for(L(d,c.length),b=0;b<c.length;b++)c[b]=0}});X.prototype.create_inbound_from=I(function(b,c,d){c=J(c);var e=K(c);d=J(d);var f=K(d);try{Y(a._olm_create_inbound_session_from)(this.Ob,b.Ob,e,c.length,f,d.length)}finally{for(L(f,d.length),b=0;b<d.length;b++)d[b]=0}});
X.prototype.session_id=I(function(){var b=Y(a._olm_session_id_length)(this.Ob),c=K(b+1);Y(a._olm_session_id)(this.Ob,c,b);return x(c,b)});X.prototype.has_received_message=function(){return Y(a._olm_session_has_received_message)(this.Ob)?!0:!1};X.prototype.matches_inbound=I(function(b){b=J(b);var c=K(b);return Y(a._olm_matches_inbound_session)(this.Ob,c,b.length)?!0:!1});
X.prototype.matches_inbound_from=I(function(b,c){b=J(b);var d=K(b);c=J(c);var e=K(c);return Y(a._olm_matches_inbound_session_from)(this.Ob,d,b.length,e,c.length)?!0:!1});
X.prototype.encrypt=I(function(b){try{var c=Y(a._olm_encrypt_random_length)(this.Ob);var d=Y(a._olm_encrypt_message_type)(this.Ob);var e=A(b);var f=Y(a._olm_encrypt_message_length)(this.Ob,e);var k=M(c,g);var p=E(e+1);z(b,y,p,e+1);var v=E(f+1);Y(a._olm_encrypt)(this.Ob,p,e,k,c,v,f);r(v+f);return{type:d,body:x(v,f)}}finally{void 0!==k&&L(k,c),void 0!==p&&(L(p,e+1),G(p)),void 0!==v&&G(v)}});
X.prototype.decrypt=I(function(b,c){try{var d=E(c.length);za(c,d);var e=Y(a._olm_decrypt_max_plaintext_length)(this.Ob,b,d,c.length);za(c,d);var f=E(e+1);var k=Y(a._olm_decrypt)(this.Ob,b,d,c.length,f,e);r(f+k);return x(f,k)}finally{void 0!==d&&G(d),void 0!==f&&(L(f,e),G(f))}});X.prototype.describe=I(function(){try{var b=E(256);Y(a._olm_session_describe)(this.Ob,b,256);return x(b)}finally{void 0!==b&&G(b)}});function Z(){var b=a._olm_utility_size();this.Pb=E(b);this.Ob=a._olm_utility(this.Pb)}
function Za(b){return function(){var c=b.apply(this,arguments);if(c===h)throw c=x(a._olm_utility_last_error(arguments[0])),Error("OLM."+c);return c}}Z.prototype.free=function(){a._olm_clear_utility(this.Ob);G(this.Ob)};Z.prototype.sha256=I(function(b){var c=Za(a._olm_sha256_length)(this.Ob);b=J(b);var d=K(b),e=K(c+1);try{Za(a._olm_sha256)(this.Ob,d,b.length,e,c)}finally{for(L(d,b.length),d=0;d<b.length;d++)b[d]=0}return x(e,c)});Z.prototype.sha256_bytes=Z.prototype.sha256;
Z.prototype.ed25519_verify=I(function(b,c,d){b=J(b);var e=K(b);c=J(c);var f=K(c);d=J(d);var k=K(d);try{Za(a._olm_ed25519_verify)(this.Ob,e,b.length,f,c.length,k,d.length)}finally{for(L(f,c.length),b=0;b<c.length;b++)c[b]=0}});olm_exports.Account=V;olm_exports.Session=X;olm_exports.Utility=Z;olm_exports.PkEncryption=Wa;olm_exports.PkDecryption=Q;olm_exports.PkSigning=Xa;olm_exports.SAS=S;
olm_exports.get_library_version=I(function(){var b=K(3);a._olm_get_library_version(b,b+1,b+2);return[va(b,"i8"),va(b+1,"i8"),va(b+2,"i8")]});


  return Module.ready
}
);
})();
if (typeof exports === 'object' && typeof module === 'object')
  module.exports = Module;
else if (typeof define === 'function' && define['amd'])
  define([], function() { return Module; });
else if (typeof exports === 'object')
  exports["Module"] = Module;
var olmInitPromise;

olm_exports['init'] = function(opts) {
    if (olmInitPromise) return olmInitPromise;

    if (opts) OLM_OPTIONS = opts;

    olmInitPromise = new Promise(function(resolve, reject) {
        onInitSuccess = function() {
            resolve();
        };
        onInitFail = function(err) {
            reject(err);
        };
        Module();
    });
    return olmInitPromise;
};

return olm_exports;

})();

if (typeof(window) !== 'undefined') {
    // We've been imported directly into a browser. Define the global 'Olm' object.
    // (we do this even if module.exports was defined, because it's useful to have
    // Olm in the global scope for browserified and webpacked apps.)
    window["Olm"] = Olm;
}

if (typeof module === 'object') {
    // Emscripten sets the module exports to be its module
    // with wrapped c functions. Clobber it with our higher
    // level wrapper class.
    module.exports = Olm;
}

// @license-end

